#include<iostream>
#include<algorithm>
#include<vector>
#define MAXN 300000
using namespace std;
struct station {
    int x;
    int f;
    int r;
};
vector <station> stations,order;
long long int initial[MAXN+1];
long long int tree[4*(MAXN+1)],lazy[4*(MAXN+1)];
void build_tree (int ind, int l, int r) {
    if (l==r) {
        tree[ind]=initial[l];
        return ;
    }
    int mid=(l+r)/2;
    build_tree(2*ind+1,l,mid);
    build_tree(2*ind+2,mid+1,r);
    tree[ind]=min(tree[2*ind+1],tree[2*ind+2]);
}
void push (int ind, int l, int r) {
    tree[ind]+=lazy[ind];
    if (l!=r) {
        lazy[2*ind+1]+=lazy[ind];
        lazy[2*ind+2]+=lazy[ind];
    }
    lazy[ind]=0;
}
void update (int ind, int l, int r, int ql, int qr, int val) {
    push(ind,l,r);
    if ((ql<=l)&&(r<=qr)) {
        lazy[ind]+=val;
        push(ind,l,r);
        return ;
    }
    int mid=(l+r)/2;
    if (ql<=mid) update(2*ind+1,l,mid,ql,qr,val);
    else push(2*ind+1,l,mid);
    if (qr>mid) update(2*ind+2,mid+1,r,ql,qr,val);
    else push(2*ind+2,mid+1,r);
    tree[ind]=min(tree[2*ind+1],tree[2*ind+2]);
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,l;
    cin >> n >> l ;
    stations.resize(n);
    for (auto& [x, f, r] : stations) {
        cin >> x >> f >> r ;
    }
    stations.push_back({l, 0, (int)1e9});
    n++;

    sort(stations.begin(),stations.end(),[] (station& s1, station& s2) {
         if (s1.x<s2.x) return true;
         if ((s1.x==s2.x)&&(s1.r<s2.r)) return true;
         return false;
    });
    long long int sumf=0;
    for (int i=0; i<n; i++) {
        auto [x, f, r]=stations[i];
        initial[i]=sumf-x;
        sumf+=f;
    }
    build_tree(0,0,n-1);

    order.reserve(n);
    for (int i=0; i<n; i++) {
        auto [x, f, r]=stations[i];
        order.push_back({i, f, r});
    }
    sort(order.begin(),order.end(),[] (station& s1, station& s2){
         if (s1.r<s2.r) return true;
         return false;
    });
    int prv=0;
    for (int i=0; i<n; i++) {
        update(0,0,n-1,0,n-1,order[i].r-prv);
        prv=order[i].r;
        if (tree[0]>=0) {
            cout << order[i].r-tree[0] ;
            break;
        }
        for (int j=i; j<n; j++) {
            auto [x, f, r]=order[j];
            if (r!=order[i].r) {
                i=j-1;
                break;
            }
            if (x!=n-1) update(0,0,n-1,x+1,n-1,-f);
            if (j==n-1) i=n-1;
        }
    }
    cout << endl ;
    return 0;
}
